## python3.2 3.2

=== Doc/Makefile ===
#
# Makefile for Python documentation
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
#

# You can set these variables from the command line.
PYTHON       = python
SVNROOT      = http://svn.python.org/projects
SPHINXOPTS   =
PAPER        =
SOURCES      =
DISTVERSION  = $(shell $(PYTHON) tools/sphinxext/patchlevel.py)

ALLSPHINXOPTS = -b $(BUILDER) -d build/doctrees -D latex_paper_size=$(PAPER) \
                $(SPHINXOPTS) . build/$(BUILDER) $(SOURCES)

.PHONY: help checkout update build html htmlhelp latex text changes linkcheck \
	suspicious coverage doctest pydoc-topics htmlview clean dist check serve \
	autobuild-dev autobuild-stable

help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  clean      to remove build files"
	@echo "  update     to update build tools"
	@echo "  html       to make standalone HTML files"
	@echo "  htmlhelp   to make HTML files and a HTML help project"
	@echo "  latex      to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
	@echo "  text       to make plain text files"
	@echo "  epub       to make EPUB files"
	@echo "  changes    to make an overview over all changed/added/deprecated items"
	@echo "  linkcheck  to check all external links for integrity"
	@echo "  coverage   to check documentation coverage for library and C API"
	@echo "  doctest    to run doctests in the documentation"
	@echo "  pydoc-topics  to regenerate the pydoc topics file"
	@echo "  dist       to create a \"dist\" directory with archived docs for download"
	@echo "  suspicious to check for suspicious markup in output text"
	@echo "  check      to run a check for frequent markup errors"
	@echo "  serve      to serve the documentation on the localhost (8000)"

# Note: if you update versions here, do the same in make.bat and README.txt
checkout:
	@if [ ! -d tools/sphinx ]; then \
	  echo "Checking out Sphinx..."; \
	  svn checkout $(SVNROOT)/external/Sphinx-1.0.7/sphinx tools/sphinx; \
	fi
	@if [ ! -d tools/docutils ]; then \
	  echo "Checking out Docutils..."; \
	  svn checkout $(SVNROOT)/external/docutils-0.6/docutils tools/docutils; \
	fi
	@if [ ! -d tools/jinja2 ]; then \
	  echo "Checking out Jinja..."; \
	  svn checkout $(SVNROOT)/external/Jinja-2.3.1/jinja2 tools/jinja2; \
	fi
	@if [ ! -d tools/pygments ]; then \
	  echo "Checking out Pygments..."; \
	  svn checkout $(SVNROOT)/external/Pygments-1.3.1/pygments tools/pygments; \
	fi

update: clean checkout

build: checkout
	mkdir -p build/$(BUILDER) build/doctrees
	$(PYTHON) tools/sphinx-build.py $(ALLSPHINXOPTS)
	@echo

html: BUILDER = html
html: build
	@echo "Build finished. The HTML pages are in build/html."

htmlhelp: BUILDER = htmlhelp
htmlhelp: build
	@echo "Build finished; now you can run HTML Help Workshop with the" \
	      "build/htmlhelp/pydoc.hhp project file."

latex: BUILDER = latex
latex: build
	@echo "Build finished; the LaTeX files are in build/latex."
	@echo "Run \`make all-pdf' or \`make all-ps' in that directory to" \
	      "run these through (pdf)latex."

text: BUILDER = text
text: build
	@echo "Build finished; the text files are in build/text."

epub: BUILDER = epub
epub: build
	@echo "Build finished; the epub files are in build/epub."

changes: BUILDER = changes
changes: build
	@echo "The overview file is in build/changes."

linkcheck: BUILDER = linkcheck
linkcheck: build
	@echo "Link check complete; look for any errors in the above output" \
	      "or in build/$(BUILDER)/output.txt"

suspicious: BUILDER = suspicious
suspicious: build
	@echo "Suspicious check complete; look for any errors in the above output" \
	      "or in build/$(BUILDER)/suspicious.csv.  If all issues are false" \
	      "positives, append that file to tools/sphinxext/susp-ignored.csv."

coverage: BUILDER = coverage
coverage: build
	@echo "Coverage finished; see c.txt and python.txt in build/coverage"

doctest: BUILDER = doctest
doctest: build
	@echo "Testing of doctests in the sources finished, look at the" \
	      "results in build/doctest/output.txt"

pydoc-topics: BUILDER = pydoc-topics
pydoc-topics: build
	@echo "Building finished; now copy build/pydoc-topics/topics.py" \
	      "to Lib/pydoc_data/topics.py"

htmlview: html
	 $(PYTHON) -c "import webbrowser; webbrowser.open('build/html/index.html')"

clean:
	-rm -rf build/*
	-rm -rf tools/sphinx
	-rm -rf tools/pygments
	-rm -rf tools/jinja2
	-rm -rf tools/docutils

dist:
	rm -rf dist
	mkdir -p dist

	# archive the HTML
	make html
	cp -pPR build/html dist/python-$(DISTVERSION)-docs-html
	tar -C dist -cf dist/python-$(DISTVERSION)-docs-html.tar python-$(DISTVERSION)-docs-html
	bzip2 -9 -k dist/python-$(DISTVERSION)-docs-html.tar
	(cd dist; zip -q -r -9 python-$(DISTVERSION)-docs-html.zip python-$(DISTVERSION)-docs-html)
	rm -r dist/python-$(DISTVERSION)-docs-html
	rm dist/python-$(DISTVERSION)-docs-html.tar

	# archive the text build
	make text
	cp -pPR build/text dist/python-$(DISTVERSION)-docs-text
	tar -C dist -cf dist/python-$(DISTVERSION)-docs-text.tar python-$(DISTVERSION)-docs-text
	bzip2 -9 -k dist/python-$(DISTVERSION)-docs-text.tar
	(cd dist; zip -q -r -9 python-$(DISTVERSION)-docs-text.zip python-$(DISTVERSION)-docs-text)
	rm -r dist/python-$(DISTVERSION)-docs-text
	rm dist/python-$(DISTVERSION)-docs-text.tar

	# archive the A4 latex
	rm -rf build/latex
	make latex PAPER=a4
	-sed -i 's/makeindex/makeindex -q/' build/latex/Makefile
	(cd build/latex; make clean && make all-pdf && make FMT=pdf zip bz2)
	cp build/latex/docs-pdf.zip dist/python-$(DISTVERSION)-docs-pdf-a4.zip
	cp build/latex/docs-pdf.tar.bz2 dist/python-$(DISTVERSION)-docs-pdf-a4.tar.bz2

	# archive the letter latex
	rm -rf build/latex
	make latex PAPER=letter
	-sed -i 's/makeindex/makeindex -q/' build/latex/Makefile
	(cd build/latex; make clean && make all-pdf && make FMT=pdf zip bz2)
	cp build/latex/docs-pdf.zip dist/python-$(DISTVERSION)-docs-pdf-letter.zip
	cp build/latex/docs-pdf.tar.bz2 dist/python-$(DISTVERSION)-docs-pdf-letter.tar.bz2

	# archive the epub build
	rm -rf build/epub
	make epub
	mkdir -p dist/python-$(DISTVERSION)-docs-epub
	cp -pPR build/epub/*.epub dist/python-$(DISTVERSION)-docs-epub/
	tar -C dist -cf dist/python-$(DISTVERSION)-docs-epub.tar python-$(DISTVERSION)-docs-epub
	bzip2 -9 -k dist/python-$(DISTVERSION)-docs-epub.tar
	(cd dist; zip -q -r -9 python-$(DISTVERSION)-docs-epub.zip python-$(DISTVERSION)-docs-epub)
	rm -r dist/python-$(DISTVERSION)-docs-epub
	rm dist/python-$(DISTVERSION)-docs-epub.tar

check:
	$(PYTHON) tools/rstlint.py -i tools

serve:
	../Tools/scripts/serve.py build/html

# Targets for daily automated doc build

# for development releases: always build
autobuild-dev:
	make update
	make dist SPHINXOPTS='-A daily=1'

# for stable releases: only build if not in pre-release stage (alpha, beta, rc)
autobuild-stable:
	@case $(DISTVERSION) in *[abc]*) \
		echo "Not building; $(DISTVERSION) is not a release version."; \
		exit 1;; \
	esac
	@make autobuild-dev

## python3.2 3.2.3-maemo3

=== debian/changelog ===
python3.2 (3.2.3-maemo3) unstable; urgency=low

  * only for armel (because of gcc-4.6)

 -- Aapo Rantalainen <aapo.rantalainen@gmail.com>  Sun, 10 Nov 2013 19:08:09 +0200

python3.2 (3.2.3-maemo2) unstable; urgency=low

  * without-system-expat 
  * Not optificated.
  * drop regrtest.py

 -- Aapo Rantalainen <aapo.rantalainen@gmail.com>  Fri, 1 Nov 2013 09:29:09 +0200

python3.2 (3.2.3-maemo1) unstable; urgency=low

  * without-system-expat 
  * Not optificated.

 -- Aapo Rantalainen <aapo.rantalainen@gmail.com>  Tue, 29 Oct 2013 22:15:09 +0200

python3.2 (3.2.3-7) unstable; urgency=low

  * distutils: Append the abiflags to the python include dir.

 -- Matthias Klose <doko@debian.org>  Wed, 20 Feb 2013 15:21:14 +0100

python3.2 (3.2.3-6) unstable; urgency=low

  * Don't run the testsuite on the Hurd and kfreebsd (as already done
    for python2.7).
  * Encode the version in the devhelp documentation name. LP: #787039.

 -- Matthias Klose <doko@debian.org>  Mon, 10 Sep 2012 00:21:05 +0200

python3.2 (3.2.3-5) unstable; urgency=low

  * Hint on installing the python-gdbm package on failing _gdbm import.
    LP: #995616.
  * Enable verbose build for the sharedmods target.
  * libpython3.2: Fix libpython3.2.so symlink. Closes: #686374.
  * Fix issue #15847: allow args to be a tuple in parse_args.
  * Fix issue #15340: Fix importing the random module when /dev/urandom cannot
    be opened.  Regression caused by the hash randomization patch.
  * Don't use `-n' anymore to start idle in the desktop/menu files, not
    needed anymore for multiseat installations.

 -- Matthias Klose <doko@debian.org>  Sun, 09 Sep 2012 15:10:19 +0200

python3.2 (3.2.3-4) unstable; urgency=low

  * Update to 20120826 from the 3.2 branch. Linux relevant fixes:
    - Follwup for issue #9374. Restore the removed attributes in the
      urlparse module.
    - Issue #14579: Fix CVE-2012-2135: vulnerability in the utf-16 decoder
      after error handling.
    - Issue #15404: Refleak in PyMethodObject repr.
    - Issue #15394: An issue in PyModule_Create that caused references to
      be leaked on some error paths has been fixed.
    - Issue #15368: An issue that caused bytecode generation to be
      non-deterministic when using randomized hashing (-R) has been fixed.
    - Issue #15424: Add a __sizeof__ implementation for array objects.
    - Issue #13052: Fix IDLE crashing when replace string in Search/Replace
      dialog ended with '\'.
    - Issue #15538: Fix compilation of the getnameinfo() / getaddrinfo()
      emulation code.
    - Issue #15726: Fix incorrect bounds checking in PyState_FindModule.
    - Issue #15604: Update uses of PyObject_IsTrue() to check for and handle
      errors correctly.
    - Issue #9803: Don't close IDLE on saving if breakpoint is open.
    - Issue #12288: Consider '0' and '0.0' as valid initialvalue
      for tkinter SimpleDialog.
    - Issue #11062: Fix adding a message from file to Babyl mailbox.
    - Issue #15544: Fix Decimal.__float__ to work with payload-carrying NaNs.
    - Issue #15249: BytesGenerator now correctly mangles From lines (when
      requested) even if the body contains undecodable bytes.
    - Issue #15777: Fix a refleak in _posixsubprocess.
    - Issue #15199: Fix JavaScript's default MIME type to
      application/javascript.
    - Issue #13579: string.Formatter now understands the 'a' conversion
      specifier.
    - Issue #15595: Fix subprocess.Popen(universal_newlines=True)
      for certain locales (utf-16 and utf-32 family). Patch by Chris Jerdonek.
    - Issue #15477: In cmath and math modules, add workaround for platforms
      whose system-supplied log1p function doesn't respect signs of zeros.
    - Issue #15512: Add a __sizeof__ implementation for parser.
    - Issue #15469: Add a __sizeof__ implementation for deque objects.
    - Issue #15489: Add a __sizeof__ implementation for BytesIO objects.
    - Issue #15487: Add a __sizeof__ implementation for buffered I/O objects.
    - Issue #6056: Make multiprocessing use setblocking(True) on the
      sockets it uses.
    - Issue #15041: update "see also" list in tkinter documentation.
    - Issue #15402: An issue in the struct module that caused sys.getsizeof to
      return incorrect results for struct.Struct instances has been fixed.
    - Issue #15232: when mangle_from is True, email.Generator now correctly
      mangles lines that start with 'From ' that occur in a MIME preamble
      or epilogue.
    - Issue #13922: argparse no longer incorrectly strips '--'s that appear
      after the first one.
    - Issue #12353: argparse now correctly handles null argument values.
    - Issues #10017 and #14998: Fix TypeError using pprint on dictionaries with
      user-defined types as keys or other unorderable keys.
    - Issue #14635: telnetlib will use poll() rather than select() when possible
      to avoid failing due to the select() file descriptor limit.
    - Issue #15645: Ensure 2to3 grammar pickles are properly installed.
    - Issue #15180: Clarify posixpath.join() error message when mixing
      str & bytes.
    - Issue #15230: runpy.run_path now correctly sets __package__ as described
      in the documentation
    - Issue #15467: Move helpers for __sizeof__ tests into test_support.
    - Issue #15320: Make iterating the list of tests thread-safe when running
      tests in multiprocess mode.
    - Issue #15230: Adopted a more systematic approach in the runpy tests
    - Issue #15747: ZFS always returns EOPNOTSUPP when attempting to set the
      UF_IMMUTABLE flag (via either chflags or lchflags); refactor affected
      tests in test_posix.py to account for this.
    - Issue #15285: Refactor the approach for testing connect timeouts using
      two external hosts that have been configured specifically for this type
      of test.
    - Issue #15615: Add some tests for the json module's handling of invalid
      input data.
    - Issue #15630: Add an example for "continue" stmt in the tutorial.


=== debian/control ===
Source: python3.2
Section: python
Priority: optional
Maintainer: Matthias Klose <doko@debian.org>
Build-Depends: debhelper (>= 5.0.51~), quilt, autoconf2.67, libreadline5-dev, libncursesw5-dev (>= 5.3), zlib1g-dev, libdb-dev, libgdbm-dev, tk8.5-dev, blt-dev (>= 2.4z), libssl-dev, sharutils, libbz2-dev, libexpat1-dev, libbluetooth3-dev [linux-any], locales [!armel !avr32 !hppa !ia64 !mipsel], libsqlite3-dev, libffi-dev (>= 3.0.5), mime-support, libgpm2 [linux-any], netbase, lsb-release, bzip2, gdb, python, xvfb, xauth, gcc-4.6, binutils2.22, python2.5, python-sphinx
Build-Conflicts: autoconf2.13
Standards-Version: 3.9.3
Vcs-Browser: https://code.launchpad.net/~doko/python/pkg3.2-debian
Vcs-Bzr: http://bazaar.launchpad.net/~doko/python/pkg3.2-debian

Package: python3.2
Architecture: armel
Priority: optional
Depends: python3.2-minimal (= ${binary:Version}), mime-support, ${shlibs:Depends}, ${misc:Depends}
Suggests: python3.2-doc, binutils
Provides: python3.2-cjkcodecs, python3.2-ctypes, python3.2-elementtree, python3.2-celementtree, python3.2-wsgiref, python3.2-gdbm, python3.2-profiler
Conflicts: python3-profiler (<= 3.2-2)
Breaks: python-virtualenv (<< 1.7.1.2-2~)
Replaces: python3-profiler (<= 3.2-2)
Description: Interactive high-level object-oriented language (version 3.2)
 Version 3.2 of the high-level, interactive object oriented language,
 includes an extensive class library with lots of goodies for
 network programming, system administration, sounds and graphics.

Package: python3.2-minimal
Architecture: armel
Priority: optional
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: python3.2
Suggests: binfmt-support
Replaces: python3.2 (<< 3.2~b2-1~)
Conflicts: binfmt-support (<< 1.1.2)
Description: Minimal subset of the Python language (version 3.2)
 This package contains the interpreter and some essential modules.  It can
 be used in the boot process for some basic tasks.
 See /usr/share/doc/python3.2-minimal/README.Debian for a list of the modules
 contained in this package.

Package: libpython3.2
Architecture: armel
Section: libs
Priority: optional
Depends: python3.2 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Replaces: python3.2 (<< 3.0~rc1)
Description: Shared Python runtime library (version 3.2)
 Version 3.2 of the high-level, interactive object oriented language,
 includes an extensive class library with lots of goodies for
 network programming, system administration, sounds and graphics.
 .
 This package contains the shared runtime library, normally not needed
 for programs using the statically linked interpreter.

Package: python3.2-examples
Architecture: armel
Depends: python3.2 (>= ${source:Version}), ${misc:Depends}
Description: Examples for the Python language (v3.2)
 Examples, Demos and Tools for Python (v3.2). These are files included in
 the upstream Python distribution (v3.2).

Package: python3.2-dev
Architecture: armel
Depends: python3.2 (= ${binary:Version}), libpython3.2 (= ${binary:Version}), libssl-dev, libexpat1-dev, ${shlibs:Depends}, ${misc:Depends}
Replaces: python3.2 (<< 3.2.2-4)
Recommends: libc6-dev | libc-dev
Description: Header files and a static library for Python (v3.2)
 Header files, a static library and development tools for building
 Python (v3.2) modules, extending the Python interpreter or embedding
 Python (v3.2) in applications.
 .
 Maintainers of Python packages should read README.maintainers.

Package: idle-python3.2
Architecture: armel
Depends: python3.2, python3-tk, python3.2-tk, ${misc:Depends}
Enhances: python3.2
Description: IDE for Python (v3.2) using Tkinter
 IDLE is an Integrated Development Environment for Python (v3.2).
 IDLE is written using Tkinter and therefore quite platform-independent.

Package: python3.2-doc
Section: doc
Architecture: armel
Depends: libjs-jquery, libjs-underscore, ${misc:Depends}
Suggests: python3.2
Description: Documentation for the high-level object-oriented language Python (v3.2)
 These is the official set of documentation for the interactive high-level
 object-oriented language Python (v3.2). All documents are provided
 in HTML format. The package consists of ten documents:
 .
   * What's New in Python3.2
   * Tutorial
   * Python Library Reference
   * Macintosh Module Reference
   * Python Language Reference
   * Extending and Embedding Python
   * Python/C API Reference
   * Installing Python Modules
   * Documenting Python
   * Distributing Python Modules

Package: python3.2-dbg
Section: debug
Architecture: armel
Priority: extra
Depends: python3.2 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}, python
Suggests: python3-gdbm-dbg, python3-tk-dbg
Description: Debug Build of the Python Interpreter (version 3.2)
 Python interpreter configured with --pydebug. Dynamically loaded modules are
 searched in /usr/lib/python3.2/lib-dynload/debug first.

=== debian/rules ===
#!/usr/bin/make -f
# Sample debian/rules that uses debhelper. GNU copyright 1997 by Joey Hess.

unexport LANG LC_ALL LC_CTYPE LC_COLLATE LC_TIME LC_NUMERIC LC_MESSAGES
unexport CFLAGS CXXFLAGS CPPFLAGS

export SHELL = /bin/bash

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

vafilt		= $(subst $(2)=,,$(filter $(2)=%,$(1)))
DPKG_VARS	:= $(shell dpkg-architecture)
DEB_HOST_ARCH		?= $(call vafilt,$(DPKG_VARS),DEB_HOST_ARCH)
DEB_HOST_ARCH_OS	?= $(call vafilt,$(DPKG_VARS),DEB_HOST_ARCH_OS)

CHANGELOG_VARS := $(shell dpkg-parsechangelog | \
	sed -n 's/ /_/g;/^[^_]/s/^\([^:]*\):_\(.*\)/\1=\2/p')
PKGSOURCE  := $(call vafilt,$(CHANGELOG_VARS),Source)
PKGVERSION := $(call vafilt,$(CHANGELOG_VARS),Version)

on_buildd := $(shell [ -f /CurrentlyBuilding -o "$$LOGNAME" = buildd ] && echo yes)

ifneq (,$(findstring nocheck, $(DEB_BUILD_OPTIONS)))
  WITHOUT_CHECK := yes
endif

WITHOUT_BENCH :=
ifneq (,$(findstring nobench, $(DEB_BUILD_OPTIONS)))
  WITHOUT_BENCH := yes
endif
ifneq (,$(filter $(DEB_HOST_ARCH), hurd-i386))
  WITHOUT_BENCH := disabled on $(DEB_HOST_ARCH)
endif
ifeq ($(on_buildd),yes)
  ifneq (,$(findstring $(DEB_HOST_ARCH), armel hppa mips mipsel s390))
    WITHOUT_CHECK := yes
  endif
  ifneq (,$(findstring $(DEB_HOST_ARCH), armel hppa mips mipsel s390))
    WITHOUT_BENCH := yes
  endif
endif
ifneq (,$(filter $(DEB_HOST_ARCH), hurd-i386 kfreebsd-amd64 kfreebsd-i386))
  WITHOUT_CHECK := yes
endif

#force
WITHOUT_CHECK := yes
WITHOUT_BENCH := yes


COMMA = ,
ifneq (,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
  NJOBS := -j $(subst parallel=,,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
endif

distribution := $(shell lsb_release -is)

VER=3.2
SVER=3.2~a4
NVER=3.3
PVER=python3.2
PRIORITY=$(shell echo $(VER) | tr -d '.')0

PREVVER	:= $(shell awk '/^python/ && NR > 1 {print substr($$2,2,length($$2)-2); exit}' debian/changelog)

# default versions are built from the python-defaults source package
# keep the definition to adjust package priorities.
DEFAULT_VERSION = no
STATIC_PYTHON=yes

MIN_MODS := $(shell awk '/^  / && $$2 == "module" { print $$1 }' \
		debian/PVER-minimal.README.Debian.in)
MIN_EXTS := $(shell awk '/^  / && $$2 ~ /^extension/ { print $$1 }' \
		debian/PVER-minimal.README.Debian.in)
MIN_BUILTINS := $(shell awk '/^  / && $$2 == "builtin" { print $$1 }' \
		debian/PVER-minimal.README.Debian.in)
MIN_PACKAGES := $(shell awk '/^  / && $$2 == "package" { print $$1 }' \
		debian/PVER-minimal.README.Debian.in)
MIN_ENCODINGS := $(foreach i, \
			$(filter-out \
			  big5% bz2% cp932.py cp949.py cp950.py euc_% \
			  gb% iso2022% johab.py shift_jis% , \
			  $(shell cd Lib/encodings && echo *.py)), \
			encodings/$(i)) \
		 codecs.py stringprep.py

with_tk := no
with_interp := static
#with_interp := shared

PY_INTERPRETER = /usr/bin/python$(VER)

ifeq ($(DEFAULT_VERSION),yes)
  PY_PRIO = standard
  #PYSTDDEP = , python (>= $(VER))
else
  PY_PRIO = optional
endif
ifeq ($(distribution),Ubuntu)
  PY_MINPRIO = required
  PY_MINPRIO = optional
  with_fpectl = yes
  with_udeb = yes
else
  PY_MINPRIO = $(PY_PRIO)
  with_fpectl = yes
endif

CC = gcc-4.6
LDFLAGS += -B /usr/binutils2.22/bin

DPKG_CFLAGS  := $(shell dpkg-buildflags --get CPPFLAGS; dpkg-buildflags --get CFLAGS)
DPKG_LDFLAGS := $(shell dpkg-buildflags --get LDFLAGS)
OPT_CFLAGS   := $(filter-out -O%,$(DPKG_CFLAGS)) # default is -O3
DEBUG_CFLAGS := $(patsubst -O%,-O0,$(DPKG_CFLAGS))

# on alpha, use -O2 only, use -mieee
ifeq ($(DEB_HOST_ARCH),alpha)
    OPT_CFLAGS += -mieee
    DEBUG_CFLAGS += -mieee
    EXTRA_OPT_FLAGS += -O2
endif
ifeq ($(DEB_HOST_ARCH),m68k)
    EXTRA_OPT_FLAGS += -O2
endif

ifeq ($(DEB_HOST_ARCH_OS),linux)
  ifneq (,$(findstring $(DEB_HOST_ARCH), amd64 armel armhf i386 powerpc ppc64))
    with_pgo := yes
  endif
endif

ifneq (,$(findstring $(DEB_HOST_ARCH), amd64 armel armhf i386))
  with_lto := yes
endif

ifneq (,$(findstring noopt, $(DEB_BUILD_OPTIONS)))
    OPT_CFLAGS := $(filter-out -O%, $(OPT_CFLAGS))
    EXTRA_OPT_CFLAGS = -O0
    with_pgo =
    with_lto =
endif

ifeq ($(with_lto),yes)
    LTO_CFLAGS = -g -flto
    EXTRA_OPT_CFLAGS += $(LTO_CFLAGS)
endif

make_build_target = $(if $(with_pgo),profile-opt)

buildd_static	:= $(CURDIR)/build-static
buildd_shared	:= $(CURDIR)/build-shared
buildd_debug	:= $(CURDIR)/build-debug
buildd_shdebug	:= $(CURDIR)/build-shdebug

d		:= debian/tmp
scriptdir	=  usr/share/lib/python$(VER)
scriptdir	=  usr/share/python$(VER)
scriptdir	=  usr/lib/python$(VER)

# package names and directories
p_base	:= $(PVER)
p_min	:= $(PVER)-minimal
p_lib	:= lib$(PVER)
p_tk	:= $(PVER)-tk
p_dev	:= $(PVER)-dev
p_exam	:= $(PVER)-examples
p_idle	:= idle-$(PVER)
p_doc	:= $(PVER)-doc
p_dbg	:= $(PVER)-dbg
p_udeb	:= $(PVER)-udeb

d_base	:= debian/$(p_base)
d_min	:= debian/$(p_min)
d_lib	:= debian/$(p_lib)
d_tk	:= debian/$(p_tk)
d_dev	:= debian/$(p_dev)
d_exam	:= debian/$(p_exam)
d_idle	:= debian/$(p_idle)
d_doc	:= debian/$(p_doc)
d_dbg	:= debian/$(p_dbg)
d_udeb	:= debian/$(p_udeb)

build-arch: stamps/stamp-build
build-indep: stamps/stamp-build-doc
build: build-arch
stamps/stamp-build: stamps/stamp-build-static stamps/stamp-mincheck \
    stamps/stamp-build-shared stamps/stamp-build-debug \
    stamps/stamp-build-shared-debug \
    stamps/stamp-check stamps/stamp-pystone stamps/stamp-pybench
	touch $@

PROFILE_EXCLUDES = test_compiler test_distutils test_platform test_subprocess \
	test_multiprocessing test_socketserver \
	test_thread test_threaded_import test_threadedtempfile \
	test_threading test_threading_local test_threadsignals \
	test_dbm_dumb test_dbm_ndbm test_pydoc test_sundry \
	test_signal test_ioctl test_gdb
# FIXME: test_mailxbox breaks, 20090703
PROFILE_EXCLUDES += test_mailbox
# FIXME: test_xmlrpc breaks, 20090818
PROFILE_EXCLUDES += test_xmlrpc
# FIXME: test_telnetlib uses network resources
PROFILE_EXCLUDES += test_telnetlib

PROFILE_TASK = ../Lib/test/regrtest.py \
	-x $(sort $(TEST_EXCLUDES) $(PROFILE_EXCLUDES))

stamps/stamp-build-static: stamps/stamp-configure-static
	dh_testdir
	$(MAKE) $(NJOBS) -C $(buildd_static) \
		EXTRA_CFLAGS="$(EXTRA_OPT_CFLAGS)" 
#		PROFILE_TASK='$(PROFILE_TASK)' $(make_build_target)
	touch stamps/stamp-build-static

stamps/stamp-build-shared: stamps/stamp-configure-shared
	dh_testdir
	$(MAKE) $(NJOBS) -C $(buildd_shared) \
		EXTRA_CFLAGS="$(EXTRA_OPT_CFLAGS)"
	: # build a static library with PIC objects
	$(MAKE) $(NJOBS) -C $(buildd_shared) \
		EXTRA_CFLAGS="$(EXTRA_OPT_CFLAGS)" \
		LIBRARY=libpython$(VER)mu-pic.a libpython$(VER)mu-pic.a
	touch stamps/stamp-build-shared

stamps/stamp-build-debug: stamps/stamp-configure-debug
	dh_testdir
	$(MAKE) $(NJOBS) -C $(buildd_debug) \
		EXTRA_CFLAGS="$(DEBUG_CFLAGS)"
	touch stamps/stamp-build-debug

stamps/stamp-build-shared-debug: stamps/stamp-configure-shared-debug
	dh_testdir
	: # build the shared debug library
	$(MAKE) $(NJOBS) -C $(buildd_shdebug) \
		EXTRA_CFLAGS="$(DEBUG_CFLAGS)" \
		libpython$(VER)dmu.so
	touch stamps/stamp-build-shared-debug

common_configure_args = \
		--prefix=/usr \
		--enable-ipv6 \
		--enable-loadable-sqlite-extensions \
		--with-dbmliborder=bdb:gdbm \
		--with-wide-unicode \
		--with-computed-gotos \
		--without-system-expat \

ifeq ($(DEB_HOST_ARCH), avr32)
  common_configure_args += --without-ffi
else
  common_configure_args += --with-system-ffi
endif

ifeq ($(with_fpectl),yes)
  common_configure_args += \
		--with-fpectl
endif

stamps/stamp-configure-shared: stamps/stamp-patch
	rm -rf $(buildd_shared)
	mkdir -p $(buildd_shared)
	cd $(buildd_shared) && \
	  CC="$(CC)" CFLAGS="$(OPT_CFLAGS)" LDFLAGS="$(DPKG_LDFLAGS)" \
	    ../configure \
		--enable-shared \
		$(common_configure_args)

	$(call __post_configure,$(buildd_shared))

	@echo XXXXXXX pyconfig.h
	-cat $(buildd_shared)/pyconfig.h

	touch $@

stamps/stamp-configure-static: stamps/stamp-patch
	rm -rf $(buildd_static)
	mkdir -p $(buildd_static)
	cd $(buildd_static) && \
	  CC="$(CC)" CFLAGS="$(OPT_CFLAGS)" LDFLAGS="$(DPKG_LDFLAGS)" \

=== debian/watch ===
version=3
opts=dversionmangle=s/.*\+//,uversionmangle=s/([abcr]+[1-9])$/~$1/ \
  http://www.python.org/ftp/python/3\.2(\.\d)?/Python-(3\.2[.\dabcr]*)\.tgz
